%global debug_package %{nil}
%define __python %{__python3}

# Dont provide or require internal libs. Using new rpm builtin filtering
%global _privatelibs libjack[.]so.*
%global __provides_exclude ^(%{_privatelibs})$
%global __requires_exclude ^(%{_privatelibs})$

%define rel 6

Name:           carla
Version:        1.9.14
Release:        %mkrel -c git20190227 %{rel}
Summary:        An audio plugin host
License:        GPLv2+
Group:          Sound/Utilities
Url:            http://kxstudio.linuxaudio.org/Applications:Carla
#from https://github.com/falkTX/Carla commit 737a0b0f
Source:         Carla-%{version}+git20190227.737a0b0f.tar.xz
Patch0:         python-version.patch
Patch1:         desktop-categories.patch
Patch2:         carla-systemlibs.patch
Patch3:         carla-1.9.12-added-mxml-3.0-compatility-to-XMLwrapper.patch
Patch4:         0001-Add-missing-QPainterPath-include.patch

BuildRequires:  pkgconfig(alsa)
BuildRequires:  pkgconfig(libpulse)
BuildRequires:  pkgconfig(python3)
BuildRequires:  python3-qt5-devel
BuildRequires:  pkgconfig(Qt5Core)
BuildRequires:  pkgconfig(Qt5Gui)
BuildRequires:  pkgconfig(Qt5Network)
BuildRequires:  pkgconfig(Qt5Widgets)
BuildRequires:  pkgconfig(sndfile)
BuildRequires:  pkgconfig(flac)
BuildRequires:  pkgconfig(vorbisenc)

BuildRequires:  file
BuildRequires:  python3-rdflib

# for extra native plugins
BuildRequires:  pkgconfig(fftw3)
BuildRequires:  pkgconfig(fluidsynth)
BuildRequires:  pkgconfig(libprojectM)
BuildRequires:  pkgconfig(ntk)
BuildRequires:  pkgconfig(zlib)
# for plugin GUIs
BuildRequires:  qt4-devel
BuildRequires:  pkgconfig(gtk+-2.0)
BuildRequires:  pkgconfig(gtk+-3.0)
BuildRequires:  pkgconfig(x11)
# for extra samplers support
BuildRequires:  pkgconfig(gig)
BuildRequires:  pkgconfig(liblo)
BuildRequires:  pkgconfig(mxml)
BuildRequires:  pkgconfig(pkg-config)

Requires:       python3-pyliblo
Requires:       python3-rdflib
Requires:       python3-qt5

%description
Carla is an audio plugin host, with support for many audio drivers
and plugin formats. It features automation of parameters via MIDI CC
and full OSC control. It currently supports LADSPA, DSSI, LV2, VST2/3
and AU plugin formats, plus GIG, SF2 and SFZ sounds banks.
It further supports bridging Window plugins using Wine.

%files
%doc INSTALL.md README.md doc
%{_bindir}/carla
%{_bindir}/carla-control
%{_bindir}/carla-database
%{_bindir}/carla-jack-multi
%{_bindir}/carla-jack-single
%{_bindir}/carla-patchbay
%{_bindir}/carla-rack
%{_bindir}/carla-settings
%{_bindir}/carla-single
%{_libdir}/carla/
%{_libdir}/lv2/carla.lv2/
%{_datadir}/carla/
%{_datadir}/applications/carla.desktop
%{_datadir}/applications/carla-control.desktop
%{_datadir}/icons/hicolor/*/apps/carla*.*
%{_datadir}/mime/packages/carla.xml

#--------------------------------------------------------------------
%package devel
Summary:        Header files to access Carla's API
Group:          Development/C++
Requires:       carla = %{version}-%{release}

%description devel
This package contains header files needed when writing software using
Carla's several APIs.

%files devel
%{_includedir}/carla/
%{_libdir}/pkgconfig/carla-native-plugin.pc
%{_libdir}/pkgconfig/carla-standalone.pc
%{_libdir}/pkgconfig/carla-utils.pc

#--------------------------------------------------------------------
%package vst
Summary:        CarlaRack and CarlaPatchbay VST plugins
Group:          Sound/Utilities
Requires:       carla = %{version}-%{release}

%description vst
This package contains Carla VST plugins, including CarlaPatchbayFX,
CarlaPatchbay, CarlaRackFX, and CarlaRack.

%files vst
%{_libdir}/vst/carla.vst/


%prep
%setup -q -n Carla-1.9.14+git20190227.737a0b0f
%autopatch -p1
find . -name '*.py' | xargs sed -i '1s|^#!python|#!%{__python3}|'

%build
%set_build_flags
make features
%make_build NOOPT=true

%install

%make_install  -- PREFIX="%{_prefix}" LIBDIR="%{_libdir}" PYVER="%{python3_version}"
# Move arch depended files (wrong installed)
mv %{buildroot}%{_datadir}/carla/resources/zynaddsubfx-ui %{buildroot}%{_libdir}/carla
ln -s %{_libdir}/carla/zynaddsubfx-ui %{buildroot}%{_datadir}/carla/resources/zynaddsubfx-ui


%changelog
* Fri Mar 25 2022 akien <akien> 1.9.14-0.git20190227.6.mga8
+ Revision: 1826429
- Require python3-qt5, pyliblo, rdflib

* Wed Dec 16 2020 umeabot <umeabot> 1.9.14-0.git20190227.5.mga8
+ Revision: 1658187
- Rebuild for new Qt5

* Wed Jul 29 2020 daviddavid <daviddavid> 1.9.14-0.git20190227.4.mga8
+ Revision: 1609506
- add upstream patch to fix build with Qt 5.15

* Tue Apr 28 2020 daviddavid <daviddavid> 1.9.14-0.git20190227.3.mga8
+ Revision: 1572611
- rebuild for new libprojectm 3.1.3

* Sat Feb 15 2020 umeabot <umeabot> 1.9.14-0.git20190227.2.mga8
+ Revision: 1524664
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%setup_compile_flags

* Sat Mar 30 2019 luigiwalser <luigiwalser> 1.9.14-0.git20190227.1.mga7
+ Revision: 1381969
- 1.9.14 snapshot from opensuse (aka 2.0-RC4)

* Sat Mar 30 2019 daviddavid <daviddavid> 1.9.12-0.git20181025.3.mga7
+ Revision: 1381592
- add patch from upstream zynaddsubfx to added compatibility with MXML 3.0
+ umeabot <umeabot>
- Qt5 Rebuild

* Wed Feb 27 2019 daviddavid <daviddavid> 1.9.12-0.git20181025.2.mga7
+ Revision: 1370416
- filter out private libs

* Tue Jan 15 2019 luigiwalser <luigiwalser> 1.9.12-0.git20181025.1.mga7
+ Revision: 1357050
- 1.9.12 snapshot from opensuse (aka 2.0-RC2)
- rediff patches
- add patch from opensuse to build against system flac and vorbis
- no longer builds against linuxsampler
+ daviddavid <daviddavid>
- rebuild for new fluidsynth 2.0.3

* Fri Jan 11 2019 daviddavid <daviddavid> 1.9.7-0.git20170512.10.mga7
+ Revision: 1354842
- rebuild for new Python 3.7

* Sat Sep 22 2018 umeabot <umeabot> 1.9.7-0.git20170512.9.mga7
+ Revision: 1295993
- Mageia 7 Mass Rebuild

* Tue Aug 07 2018 wally <wally> 1.9.7-0.git20170512.8.mga7
+ Revision: 1248784
- build without linuxsampler on aarch64

* Fri Jul 06 2018 daviddavid <daviddavid> 1.9.7-0.git20170512.7.mga7
+ Revision: 1242165
- update files list (no more __pycache__ reference)

* Sat Dec 30 2017 wally <wally> 1.9.7-0.git20170512.6.mga7
+ Revision: 1187990
- rebuild for new liblinuxsampler

* Wed Aug 09 2017 pterjan <pterjan> 1.9.7-0.git20170512.5.mga7
+ Revision: 1139143
- Rebuild for python 3.6

* Tue May 30 2017 pterjan <pterjan> 1.9.7-0.git20170512.4.mga6
+ Revision: 1105615
- Do not force sse+sse2 on all architectures

* Fri May 12 2017 animtim <animtim> 1.9.7-0.git20170512.3.mga6
+ Revision: 1100621
- add desktop categories patch
- fix icons path
- add missing BR
- add the patch
- fix spec and add install patch
- imported package carla

